//include <../_Modules/Module_Geometrical_Objects.scad>;
include <Module_Geometrical_Objects.scad>;


module roundedCubeWithCornerDiameter(lSizeX, lSizeY, lSizeZ, lRoundDiameter1, lRoundDiameter2, lRoundDiameter3, lRoundDiameter4)
{
	roundedCubeHalfWithDiameter(lSizeX, lSizeY, lSizeZ, lRoundDiameter1, lRoundDiameter2);
	
	/* Spiegeln um Y */
	mirror([0,1,0])
	roundedCubeHalfWithDiameter(lSizeX, lSizeY, lSizeZ, lRoundDiameter3, lRoundDiameter4);
}

module roundingCorner(lRoundDiameter, lSizeZ) // erstellt etwas, das man zum Abrunden von Kanten eines Kubus benutzen kann
{
	//rotate([0,0,45])
	translate([lRoundDiameter/2, lRoundDiameter/2, 0])
	difference()
	{
		cube([lRoundDiameter*1, lRoundDiameter*1, lSizeZ], center=true); // umschließender Kubus
		cylinder(d=lRoundDiameter, h=lSizeZ, center=true); // Zyl. ausschneiden
		translate([lRoundDiameter/2, 0, 0]) // nur eine Hälfte stehen lassen
		cube([lRoundDiameter, lRoundDiameter, lSizeZ], center=true);
		translate([-lRoundDiameter/2, lRoundDiameter/2, 0]) // nur noch ein Viertel stehen lassen
		cube([lRoundDiameter, lRoundDiameter, lSizeZ], center=true);
	}
}

module roundedCubeQuarter(lSizeX, lSizeY, lSizeZ, lRoundDiameter)
{
	difference()
	{
		/* Mal ein Viertel davon schön machen, und dann spiegeln :) */
	//	cube([lSizeX, lSizeY, lSizeZ], center=true); // der block als ganzes
		translate([-lSizeX/4, -lSizeY/4, 0])
		cube([lSizeX/2, lSizeY/2, lSizeZ], center=true); // ein viertel davon
		translate([-lSizeX/2,-lSizeY/2,0])
		roundingCorner(lRoundDiameter, lSizeZ);
		//roundingCorner(6, 5);
	}
}

module roundedCubeHalfWithDiameter(lSizeX, lSizeY, lSizeZ, lRoundDiameter1, lRoundDiameter2)
{

	roundedCubeQuarter(lSizeX, lSizeY, lSizeZ, lRoundDiameter1);

	/* Spiegeln um X */
	mirror([1,0,0])
	{
		difference()
		{
			/* Mal ein Viertel davon schön machen, und dann spiegeln :) */
/*			translate([-lSizeX/4, -lSizeY/4, 0])
			cube([lSizeX/2, lSizeY/2, lSizeZ], center=true); // ein viertel davon
			translate([-lSizeX/2,-lSizeY/2,0])
			#roundingCorner(lRoundDiameter, lSizeZ);
			*/
			roundedCubeQuarter(lSizeX, lSizeY, lSizeZ, lRoundDiameter2);
		}
	}	
}	

module roundedCubeHalf(lSizeX, lSizeY, lSizeZ, lRoundDiameter) // legacy stuff
{

	roundedCubeQuarter(lSizeX, lSizeY, lSizeZ, lRoundDiameter);

	/* Spiegeln um X */
	mirror([1,0,0])
	{
		difference()
		{
			/* Mal ein Viertel davon schön machen, und dann spiegeln :) */
/*			translate([-lSizeX/4, -lSizeY/4, 0])
			cube([lSizeX/2, lSizeY/2, lSizeZ], center=true); // ein viertel davon
			translate([-lSizeX/2,-lSizeY/2,0])
			#roundingCorner(lRoundDiameter, lSizeZ);
			*/
			roundedCubeQuarter(lSizeX, lSizeY, lSizeZ, lRoundDiameter);
		}
	}	
}	

module roundedCube(lSizeX, lSizeY, lSizeZ, lRoundDiameter)
{
	roundedCubeHalf(lSizeX, lSizeY, lSizeZ, lRoundDiameter);
	/* Spiegeln um Y */
	mirror([0,1,0])
	roundedCubeHalf(lSizeX, lSizeY, lSizeZ, lRoundDiameter);
}

/*lSizeX=100;
lSizeY=30;
lSizeZ=5;
lRoundDiameter=5;
roundedCube(lSizeX, lSizeY, lSizeZ, lRoundDiameter);*/
